import type GraphicsLayer from "@arcgis/core/layers/GraphicsLayer";
import type Layer from "@arcgis/core/layers/Layer";
import type PortalItem from "@arcgis/core/portal/PortalItem";
import type { Feature } from "../data/Feature.js";
import type { FeatureReadOptions } from "../data/FeatureSource.js";
import type { QuerySourceCapabilities } from "../data/QuerySourceCapabilities.js";
import { type FeatureLayerJson } from "../json/FeatureLayerJson.js";
import type { PropertyDefs } from "../support/Serializable.js";
import type { LayerExtensionProperties, LayerProperties } from "./_LayerExtension.js";
import { LayerExtension } from "./_LayerExtension.js";
/**
 * Ref type for graphics layer extension.
 */
export declare const GRAPHICS_LAYER_TYPE = "graphics-layer";
/**
 * Properties that can be passed into the constructor for
 * {@link GraphicsLayerExtension}.
 */
export interface GraphicsLayerExtensionProperties extends LayerExtensionProperties {
    /**
     * The Esri GraphicsLayer object being extended.
     */
    layer?: GraphicsLayer | (FeatureLayerJson & LayerProperties);
}
/**
 * Extends the capabilities of an Esri GraphicsLayer object.
 */
export declare class GraphicsLayerExtension extends LayerExtension<GraphicsLayerExtensionProperties> {
    get hasFeatures(): boolean;
    get layer(): GraphicsLayer;
    constructor(properties?: GraphicsLayerExtensionProperties);
    protected _onInitialize(): Promise<void>;
    protected _applyLayerProperties(properties: LayerProperties, layer: Layer): Promise<void>;
    protected _getFeatures(ids: string[], _options?: FeatureReadOptions): AsyncIterable<Feature>;
    protected _getSerializableProperties(): PropertyDefs<GraphicsLayerExtensionProperties>;
    /**
     * @inheritDoc
     */
    protected _isSupportedLayer(layer: Layer): boolean;
    protected _applyPortalItemProperties(portalItem: PortalItem): Promise<void>;
    protected _capabilities(): QuerySourceCapabilities;
    protected _getSerializableLayerType(): string;
    protected _getSerializableRefLayerProperties(): Record<string, unknown>;
}
